//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Hidden/Universal Render Pipeline/Terrain/Lit (Basemap Gen)" {
    Properties {
        _NumLayersCount ("Total Layer Count", Float) = 1
        _Control ("AlphaMap", 2D) = "" { }
        _Splat0 ("Layer 0 (R)", 2D) = "white" { }
        _Splat1 ("Layer 1 (G)", 2D) = "white" { }
        _Splat2 ("Layer 2 (B)", 2D) = "white" { }
        _Splat3 ("Layer 3 (A)", 2D) = "white" { }
        _Mask3 ("Mask 3 (A)", 2D) = "grey" { }
        _Mask2 ("Mask 2 (B)", 2D) = "grey" { }
        _Mask1 ("Mask 1 (G)", 2D) = "grey" { }
        _Mask0 ("Mask 0 (R)", 2D) = "grey" { }
        _Metallic0 ("Metallic 0", Range(0, 1)) = 0
        _Metallic1 ("Metallic 1", Range(0, 1)) = 0
        _Metallic2 ("Metallic 2", Range(0, 1)) = 0
        _Metallic3 ("Metallic 3", Range(0, 1)) = 0
        _Smoothness0 ("Smoothness 0", Range(0, 1)) = 1
        _Smoothness1 ("Smoothness 1", Range(0, 1)) = 1
        _Smoothness2 ("Smoothness 2", Range(0, 1)) = 1
        _Smoothness3 ("Smoothness 3", Range(0, 1)) = 1
        _DstBlend ("DstBlend", Float) = 0
    }
    SubShader {
        Pass {
            Tags { "Format" = "ARGB32" "Name" = "_MainTex" "Size" = "1" }
            ZTest Always
            ZWrite Off
            Cull Off
            GpuProgramID 17283
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform _Terrain {
                    #endif
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale3;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic3;
                    	UNITY_UNIFORM float                _Smoothness0;
                    	UNITY_UNIFORM float                _Smoothness1;
                    	UNITY_UNIFORM float                _Smoothness2;
                    	UNITY_UNIFORM float                _Smoothness3;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale0;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale1;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale2;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale3;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Control_ST;
                    	UNITY_UNIFORM vec4                _Control_TexelSize;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha3;
                    	UNITY_UNIFORM float                _LayerHasMask0;
                    	UNITY_UNIFORM float                _LayerHasMask1;
                    	UNITY_UNIFORM float                _LayerHasMask2;
                    	UNITY_UNIFORM float                _LayerHasMask3;
                    	UNITY_UNIFORM vec4                _Splat0_ST;
                    	UNITY_UNIFORM vec4                _Splat1_ST;
                    	UNITY_UNIFORM vec4                _Splat2_ST;
                    	UNITY_UNIFORM vec4                _Splat3_ST;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_HeightTransition;
                    	UNITY_UNIFORM float                _NumLayersCount;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec4 in_POSITION0;
                    in highp vec2 in_TEXCOORD0;
                    out highp vec4 vs_TEXCOORD0;
                    out highp vec4 vs_TEXCOORD1;
                    out highp vec4 vs_TEXCOORD2;
                    out highp vec3 vs_TEXCOORD3;
                    highp  vec4 phase0_Output0_3;
                    out highp float vs_TEXCOORD6;
                    out highp vec3 vs_TEXCOORD4;
                    out highp vec3 vs_TEXCOORD7;
                    vec4 u_xlat0;
                    void main()
                    {
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        vs_TEXCOORD0.zw = vec2(0.0, 0.0);
                        vs_TEXCOORD1.xy = in_TEXCOORD0.xy * _Splat0_ST.xy + _Splat0_ST.zw;
                        vs_TEXCOORD1.zw = in_TEXCOORD0.xy * _Splat1_ST.xy + _Splat1_ST.zw;
                        vs_TEXCOORD2.xy = in_TEXCOORD0.xy * _Splat2_ST.xy + _Splat2_ST.zw;
                        vs_TEXCOORD2.zw = in_TEXCOORD0.xy * _Splat3_ST.xy + _Splat3_ST.zw;
                        phase0_Output0_3 = vec4(0.0, 0.0, 0.0, 0.0);
                        vs_TEXCOORD4.xyz = vec3(0.0, 0.0, 0.0);
                        vs_TEXCOORD7.xyz = vec3(0.0, 0.0, 0.0);
                        u_xlat0 = in_POSITION0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[0] * in_POSITION0.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * in_POSITION0.zzzz + u_xlat0;
                        gl_Position = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                    vs_TEXCOORD3 = phase0_Output0_3.xyz;
                    vs_TEXCOORD6 = phase0_Output0_3.w;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform _Terrain {
                    #endif
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale3;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Metallic3;
                    	UNITY_UNIFORM float                _Smoothness0;
                    	UNITY_UNIFORM float                _Smoothness1;
                    	UNITY_UNIFORM float                _Smoothness2;
                    	UNITY_UNIFORM float                _Smoothness3;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale0;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale1;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale2;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale3;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Control_ST;
                    	UNITY_UNIFORM vec4                _Control_TexelSize;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha3;
                    	UNITY_UNIFORM float                _LayerHasMask0;
                    	UNITY_UNIFORM float                _LayerHasMask1;
                    	UNITY_UNIFORM float                _LayerHasMask2;
                    	UNITY_UNIFORM float                _LayerHasMask3;
                    	UNITY_UNIFORM vec4                _Splat0_ST;
                    	UNITY_UNIFORM vec4                _Splat1_ST;
                    	UNITY_UNIFORM vec4                _Splat2_ST;
                    	UNITY_UNIFORM vec4                _Splat3_ST;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_HeightTransition;
                    	UNITY_UNIFORM float                _NumLayersCount;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _Control;
                    UNITY_LOCATION(1) uniform mediump sampler2D _Splat0;
                    UNITY_LOCATION(2) uniform mediump sampler2D _Splat1;
                    UNITY_LOCATION(3) uniform mediump sampler2D _Splat2;
                    UNITY_LOCATION(4) uniform mediump sampler2D _Splat3;
                    in highp vec4 vs_TEXCOORD0;
                    in highp vec4 vs_TEXCOORD1;
                    in highp vec4 vs_TEXCOORD2;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec4 u_xlat2;
                    vec4 u_xlat3;
                    vec4 u_xlat4;
                    vec4 u_xlat5;
                    vec4 u_xlat6;
                    vec4 u_xlat7;
                    vec4 u_xlat8;
                    bool u_xlatb28;
                    void main()
                    {
                        u_xlat0.x = _MaskMapRemapOffset0.w + _MaskMapRemapScale0.w;
                        u_xlat0.y = _MaskMapRemapOffset1.w + _MaskMapRemapScale1.w;
                        u_xlat0.z = _MaskMapRemapOffset2.w + _MaskMapRemapScale2.w;
                        u_xlat0.w = _MaskMapRemapOffset3.w + _MaskMapRemapScale3.w;
                        u_xlat1 = texture(_Splat0, vs_TEXCOORD1.xy, _GlobalMipBias.x);
                        u_xlat2.x = u_xlat1.w;
                        u_xlat3 = texture(_Splat1, vs_TEXCOORD1.zw, _GlobalMipBias.x);
                        u_xlat2.y = u_xlat3.w;
                        u_xlat4 = texture(_Splat2, vs_TEXCOORD2.xy, _GlobalMipBias.x);
                        u_xlat2.z = u_xlat4.w;
                        u_xlat5 = texture(_Splat3, vs_TEXCOORD2.zw, _GlobalMipBias.x);
                        u_xlat2.w = u_xlat5.w;
                        u_xlat0 = (-u_xlat2) * vec4(_Smoothness0, _Smoothness1, _Smoothness2, _Smoothness3) + u_xlat0;
                        u_xlat6 = u_xlat2 * vec4(_Smoothness0, _Smoothness1, _Smoothness2, _Smoothness3);
                        u_xlat0 = vec4(_LayerHasMask0, _LayerHasMask1, _LayerHasMask2, _LayerHasMask3) * u_xlat0 + u_xlat6;
                        u_xlat6.xy = _Control_TexelSize.zw + vec2(-1.0, -1.0);
                        u_xlat6.xy = vs_TEXCOORD0.xy * u_xlat6.xy + vec2(0.5, 0.5);
                        u_xlat6.xy = u_xlat6.xy * _Control_TexelSize.xy;
                        u_xlat6 = texture(_Control, u_xlat6.xy, _GlobalMipBias.x);
                        u_xlat7 = (-u_xlat6) + vec4(1.0, 1.0, 1.0, 1.0);
                        u_xlat2 = u_xlat2 + (-u_xlat7);
                        u_xlat2 = u_xlat2 * vec4(20.0, 20.0, 20.0, 20.0);
                        u_xlat2 = clamp(u_xlat2, 0.0, 1.0);
                        u_xlat2 = u_xlat6 * vec4(0.00100000005, 0.00100000005, 0.00100000005, 0.00100000005) + u_xlat2;
                        u_xlat7 = (-u_xlat2) + u_xlat6;
                        u_xlat8.x = u_xlat7.x * _DiffuseRemapScale0.w;
                        u_xlat8.y = u_xlat7.y * _DiffuseRemapScale1.w;
                        u_xlat8.z = u_xlat7.z * _DiffuseRemapScale2.w;
                        u_xlat8.w = u_xlat7.w * _DiffuseRemapScale3.w;
                        u_xlat2 = u_xlat2 + u_xlat8;
                        u_xlatb28 = 4.0>=_NumLayersCount;
                        u_xlat2 = (bool(u_xlatb28)) ? u_xlat2 : u_xlat6;
                        SV_Target0.w = dot(u_xlat2, u_xlat0);
                        u_xlat0.xyz = u_xlat2.yyy * _DiffuseRemapScale1.xyz;
                        u_xlat0.xyz = u_xlat0.xyz * u_xlat3.xyz;
                        u_xlat3.xyz = u_xlat2.xxx * _DiffuseRemapScale0.xyz;
                        u_xlat0.xyz = u_xlat1.xyz * u_xlat3.xyz + u_xlat0.xyz;
                        u_xlat1.xyz = u_xlat2.zzz * _DiffuseRemapScale2.xyz;
                        u_xlat2.xyz = u_xlat2.www * _DiffuseRemapScale3.xyz;
                        u_xlat0.xyz = u_xlat4.xyz * u_xlat1.xyz + u_xlat0.xyz;
                        SV_Target0.xyz = u_xlat5.xyz * u_xlat2.xyz + u_xlat0.xyz;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
        Pass {
            Tags { "EmptyColor" = "FF000000" "Format" = "R8" "Name" = "_MetallicTex" "Size" = "1/4" }
            ZTest Always
            ZWrite Off
            Cull Off
            GpuProgramID 67918
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform _Terrain {
                    #endif
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale3;
                    	UNITY_UNIFORM float                _Metallic0;
                    	UNITY_UNIFORM float                _Metallic1;
                    	UNITY_UNIFORM float                _Metallic2;
                    	UNITY_UNIFORM float                _Metallic3;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness3;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale0;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale1;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale2;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale1;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MaskMapRemapScale2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale3;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Control_ST;
                    	UNITY_UNIFORM vec4                _Control_TexelSize;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha3;
                    	UNITY_UNIFORM float                _LayerHasMask0;
                    	UNITY_UNIFORM float                _LayerHasMask1;
                    	UNITY_UNIFORM float                _LayerHasMask2;
                    	UNITY_UNIFORM float                _LayerHasMask3;
                    	UNITY_UNIFORM vec4                _Splat0_ST;
                    	UNITY_UNIFORM vec4                _Splat1_ST;
                    	UNITY_UNIFORM vec4                _Splat2_ST;
                    	UNITY_UNIFORM vec4                _Splat3_ST;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_HeightTransition;
                    	UNITY_UNIFORM float                _NumLayersCount;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    in highp vec4 in_POSITION0;
                    in highp vec2 in_TEXCOORD0;
                    out highp vec4 vs_TEXCOORD0;
                    out highp vec4 vs_TEXCOORD1;
                    out highp vec4 vs_TEXCOORD2;
                    out highp vec3 vs_TEXCOORD3;
                    highp  vec4 phase0_Output0_3;
                    out highp float vs_TEXCOORD6;
                    out highp vec3 vs_TEXCOORD4;
                    out highp vec3 vs_TEXCOORD7;
                    vec4 u_xlat0;
                    void main()
                    {
                        vs_TEXCOORD0.xy = in_TEXCOORD0.xy;
                        vs_TEXCOORD0.zw = vec2(0.0, 0.0);
                        vs_TEXCOORD1.xy = in_TEXCOORD0.xy * _Splat0_ST.xy + _Splat0_ST.zw;
                        vs_TEXCOORD1.zw = in_TEXCOORD0.xy * _Splat1_ST.xy + _Splat1_ST.zw;
                        vs_TEXCOORD2.xy = in_TEXCOORD0.xy * _Splat2_ST.xy + _Splat2_ST.zw;
                        vs_TEXCOORD2.zw = in_TEXCOORD0.xy * _Splat3_ST.xy + _Splat3_ST.zw;
                        phase0_Output0_3 = vec4(0.0, 0.0, 0.0, 0.0);
                        vs_TEXCOORD4.xyz = vec3(0.0, 0.0, 0.0);
                        vs_TEXCOORD7.xyz = vec3(0.0, 0.0, 0.0);
                        u_xlat0 = in_POSITION0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[0] * in_POSITION0.xxxx + u_xlat0;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[2] * in_POSITION0.zzzz + u_xlat0;
                        gl_Position = u_xlat0 + hlslcc_mtx4x4unity_MatrixVP[3];
                    vs_TEXCOORD3 = phase0_Output0_3.xyz;
                    vs_TEXCOORD6 = phase0_Output0_3.w;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec2 _GlobalMipBias;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    UNITY_BINDING(0) uniform _Terrain {
                    #endif
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_NormalScale3;
                    	UNITY_UNIFORM float                _Metallic0;
                    	UNITY_UNIFORM float                _Metallic1;
                    	UNITY_UNIFORM float                _Metallic2;
                    	UNITY_UNIFORM float                _Metallic3;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_Smoothness3;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale0;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale1;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale2;
                    	UNITY_UNIFORM vec4                _DiffuseRemapScale3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset1;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapOffset3;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale0;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale1;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_MaskMapRemapScale2;
                    	UNITY_UNIFORM vec4                _MaskMapRemapScale3;
                    	UNITY_UNIFORM vec4 Xhlslcc_UnusedX_Control_ST;
                    	UNITY_UNIFORM vec4                _Control_TexelSize;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha0;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha1;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha2;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_DiffuseHasAlpha3;
                    	UNITY_UNIFORM float                _LayerHasMask0;
                    	UNITY_UNIFORM float                _LayerHasMask1;
                    	UNITY_UNIFORM float                _LayerHasMask2;
                    	UNITY_UNIFORM float                _LayerHasMask3;
                    	UNITY_UNIFORM vec4                _Splat0_ST;
                    	UNITY_UNIFORM vec4                _Splat1_ST;
                    	UNITY_UNIFORM vec4                _Splat2_ST;
                    	UNITY_UNIFORM vec4                _Splat3_ST;
                    	UNITY_UNIFORM float Xhlslcc_UnusedX_HeightTransition;
                    	UNITY_UNIFORM float                _NumLayersCount;
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    };
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _Control;
                    UNITY_LOCATION(1) uniform mediump sampler2D _Splat0;
                    UNITY_LOCATION(2) uniform mediump sampler2D _Splat1;
                    UNITY_LOCATION(3) uniform mediump sampler2D _Splat2;
                    UNITY_LOCATION(4) uniform mediump sampler2D _Splat3;
                    in highp vec4 vs_TEXCOORD0;
                    in highp vec4 vs_TEXCOORD1;
                    in highp vec4 vs_TEXCOORD2;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout highp vec4 SV_Target0;
                    #else
                    layout(location = 0) out highp vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    vec4 u_xlat2;
                    bool u_xlatb2;
                    vec4 u_xlat3;
                    void main()
                    {
                        u_xlat0.x = texture(_Splat0, vs_TEXCOORD1.xy, _GlobalMipBias.x).w;
                        u_xlat0.y = texture(_Splat1, vs_TEXCOORD1.zw, _GlobalMipBias.x).w;
                        u_xlat0.z = texture(_Splat2, vs_TEXCOORD2.xy, _GlobalMipBias.x).w;
                        u_xlat0.w = texture(_Splat3, vs_TEXCOORD2.zw, _GlobalMipBias.x).w;
                        u_xlat1.xy = _Control_TexelSize.zw + vec2(-1.0, -1.0);
                        u_xlat1.xy = vs_TEXCOORD0.xy * u_xlat1.xy + vec2(0.5, 0.5);
                        u_xlat1.xy = u_xlat1.xy * _Control_TexelSize.xy;
                        u_xlat1 = texture(_Control, u_xlat1.xy, _GlobalMipBias.x);
                        u_xlat2 = (-u_xlat1) + vec4(1.0, 1.0, 1.0, 1.0);
                        u_xlat0 = u_xlat0 + (-u_xlat2);
                        u_xlat0 = u_xlat0 * vec4(20.0, 20.0, 20.0, 20.0);
                        u_xlat0 = clamp(u_xlat0, 0.0, 1.0);
                        u_xlat0 = u_xlat1 * vec4(0.00100000005, 0.00100000005, 0.00100000005, 0.00100000005) + u_xlat0;
                        u_xlat2 = (-u_xlat0) + u_xlat1;
                        u_xlat3.x = u_xlat2.x * _DiffuseRemapScale0.w;
                        u_xlat3.y = u_xlat2.y * _DiffuseRemapScale1.w;
                        u_xlat3.z = u_xlat2.z * _DiffuseRemapScale2.w;
                        u_xlat3.w = u_xlat2.w * _DiffuseRemapScale3.w;
                        u_xlat0 = u_xlat0 + u_xlat3;
                        u_xlatb2 = 4.0>=_NumLayersCount;
                        u_xlat0 = (bool(u_xlatb2)) ? u_xlat0 : u_xlat1;
                        u_xlat1.x = _MaskMapRemapOffset0.x + _MaskMapRemapScale0.x;
                        u_xlat1.y = _MaskMapRemapOffset1.x + _MaskMapRemapScale1.x;
                        u_xlat1.z = _MaskMapRemapOffset2.x + _MaskMapRemapScale3.x;
                        u_xlat1.w = _MaskMapRemapOffset3.x + _MaskMapRemapScale3.x;
                        u_xlat1 = u_xlat1 + (-vec4(_Metallic0, _Metallic1, _Metallic2, _Metallic3));
                        u_xlat1 = vec4(_LayerHasMask0, _LayerHasMask1, _LayerHasMask2, _LayerHasMask3) * u_xlat1 + vec4(_Metallic0, _Metallic1, _Metallic2, _Metallic3);
                        SV_Target0 = vec4(dot(u_xlat0, u_xlat1));
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
    }
}